//
//  This needs the kernel stack-poison patch to run. 
//  Merry Christmas from rjohnson@analogic.com
//  Released under GPL
//

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>


int main()
{
    size_t page;
    size_t page_size;
    size_t i;
    int fd;
    char *buf;
    page_size = getpagesize();
    if((fd = open("/dev/mem", O_RDONLY)) < 0)
    {
        fprintf(stderr, "Can't open device file for reading\n");
        exit(EXIT_FAILURE);
    }
    if((buf = malloc(page_size)) == NULL)
    {
        fprintf(stderr, "Can't allocate memory\n");
        exit(EXIT_FAILURE);
    }
//
//  Note: Stacks and poison start at a page boundary. I just
//  read a page at a time.
//
    page = 0x00;
    while(read(fd, buf, page_size) == page_size)
    {
        if(*buf == 'Q')
        {
            for(i=0; i < page_size; i++)
                if(buf[i] != 'Q')
                     break;
            if(i > 4)	// Could be a word of 'QQQQ'
                 printf("Offset : %08x\tAvailable Stack bytes = %u\n",
                                              (page * page_size), i);
        }
        page++;
    }
    free(buf);
    close(fd);
    return 0;
}

